`include "time_scale.v"
`include "i8051_lib.v"

module TB;

wire clk;
reg  clk_reg;
wire rst;
reg  rst_reg;

//dut
wire [15:0] addr;
wire [ 7:0] di, do;
wire        rd, we;
wire [ 7:0] p0_in;
wire [ 7:0] p1_in;
wire [ 7:0] p2_in;
wire [ 7:0] p3_in;
wire [ 7:0] p0_out;
wire [ 7:0] p1_out;
wire [ 7:0] p2_out;
wire [ 7:0] p3_out;
assign p0_in=8'h11;
assign p1_in=8'h22;
assign p2_in=8'h33;
assign p3_in=8'h44;

initial begin
  clk_reg=1'b0;
  forever begin
  #2000 clk_reg=1'b1;
  #3000 clk_reg=1'b0;
  end
end
assign clk=clk_reg;



initial begin
  rst_reg = 1'b1;
  repeat(2) @ (posedge clk);
  rst_reg = 1'b0;

  repeat(1000) @ (posedge clk);
  $display("sim end at %d ", $time);
  $finish;
end
assign #1 rst=rst_reg;
//xilixn GL old library
//assign     glbl.GSR = rst; 



I8051_ALL u_dut (
  .rst(rst),
  .clk(clk),

  .xrm_addr    (addr),
  .xrm_out_data(di  ),//out
  .xrm_in_data (do  ),//in
  .xrm_rd      (rd  ),
  .xrm_wr      (we  ),

  .p0_in (p0_in ),
  .p1_in (p1_in ),
  .p2_in (p2_in ),
  .p3_in (p3_in ),
  .p0_out(p0_out),
  .p1_out(p1_out),
  .p2_out(p2_out),
  .p3_out(p3_out) 
);//I8051_ALL u_dut

sram u_sram (
  .phy_clk    (clk ),
  .sram_adr_o (addr),
  .sram_data_i(do  ),//out
  .sram_data_o(di  ),//in
  .sram_re_o  (rd  ),
  .sram_we_o  (we  )
);//sram u_sram




initial begin
  $dumpfile("1.dump");
  $dumpvars(0, TB);
end

endmodule

