`include "time_scale.v"
`include "i8051_lib.v"
module DO_SUB (
    a ,
    b ,
    c ,
    r ,
    cy,
    ac,
    ov
  );
  input  [7:0] a, b;
  input        c;
  output [7:0] r;
  output       cy, ac, ov;
  
  wire [4:0] v1, v2, v3, v4;
  wire [3:0] v5, v6, v7, v8;
  wire [1:0] v9, vA, vB, vC;
  
  assign v1 = {1'b1, a[3:0]};
  assign v2 = {1'b0, b[3:0]};
  assign v3 = {1'b0, 3'b000, c};
  assign v4 = v1 - v2 - v3;
  
  assign v5 = {1'b1, a[6:4]};
  assign v6 = {1'b0, b[6:4]};
  assign v7 = {1'b0, 2'b00, (~v4[4])};
  assign v8 = v5 - v6 - v7;
  
  assign v9 = {1'b1, a[7]};
  assign vA = {1'b0, b[7]};
  assign vB = {1'b0, (~v8[3])};
  assign vC = v9 - vA - vB;
  
  assign r[7] = vC[0];
  assign r[6] = v8[2];
  assign r[5] = v8[1];
  assign r[4] = v8[0];
  assign r[3] = v4[3];
  assign r[2] = v4[2];
  assign r[1] = v4[1];
  assign r[0] = v4[0];
  assign cy = ~vC[1];
  assign ac = ~v4[4];
  assign ov = (~vC[1]) ^ (~v8[3]);
  
endmodule

