//
// Copyright (c) 1999-2000 Tony Givargis.  Permission to copy is granted
// provided that this header remains intact.  This software is provided
// with no warranties.
//
// Version : 2.8
//

//////////////////////////////////////////////////////////////////////////////-


//
// op_in : cracked opcode of the executing instruction (see I8051_LIB)
//
`include "time_scale.v"
`include "i8051_lib.v"
module I8051_DBG (op_in);
  input  [8:0]   op_in;
  
  //////////////////////////////////////////////////////////////////////////////-
  
  always @ (op_in) begin
    
    case (op_in[6:0])
      `OPC_ACALL  : $display("ACALL       %d ", $time);
      `OPC_ADD_1  : $display("ADD 1       %d ", $time);
      `OPC_ADD_2  : $display("ADD 2       %d ", $time);
      `OPC_ADD_3  : $display("ADD 3       %d ", $time);
      `OPC_ADD_4  : $display("ADD 4       %d ", $time);
      `OPC_ADDC_1 : $display("ADDC 1      %d ", $time);
      `OPC_ADDC_2 : $display("ADDC 2      %d ", $time);
      `OPC_ADDC_3 : $display("ADDC 3      %d ", $time);
      `OPC_ADDC_4 : $display("ADDC 4      %d ", $time);
      `OPC_AJMP   : $display("AJMP        %d ", $time);
      `OPC_ANL_1  : $display("ANL 1       %d ", $time);
      `OPC_ANL_2  : $display("ANL 2       %d ", $time);
      `OPC_ANL_3  : $display("ANL 3       %d ", $time);
      `OPC_ANL_4  : $display("ANL 4       %d ", $time);
      `OPC_ANL_5  : $display("ANL 5       %d ", $time);
      `OPC_ANL_6  : $display("ANL 6       %d ", $time);
      `OPC_ANL_7  : $display("ANL 7       %d ", $time);
      `OPC_ANL_8  : $display("ANL 8       %d ", $time);
      `OPC_CJNE_1 : $display("CJNE 1      %d ", $time);
      `OPC_CJNE_2 : $display("CJNE 2      %d ", $time);
      `OPC_CJNE_3 : $display("CJNE 3      %d ", $time);
      `OPC_CJNE_4 : $display("CJNE 4      %d ", $time);
      `OPC_CLR_1  : $display("CLR 1       %d ", $time);
      `OPC_CLR_2  : $display("CLR 2       %d ", $time);
      `OPC_CLR_3  : $display("CLR 3       %d ", $time);
      `OPC_CPL_1  : $display("CPL 1       %d ", $time);
      `OPC_CPL_2  : $display("CPL 2       %d ", $time);
      `OPC_CPL_3  : $display("CPL 3       %d ", $time);
      `OPC_DA     : $display("DA          %d ", $time);
      `OPC_DEC_1  : $display("DEC 1       %d ", $time);
      `OPC_DEC_2  : $display("DEC 2       %d ", $time);
      `OPC_DEC_3  : $display("DEC 3       %d ", $time);
      `OPC_DEC_4  : $display("DEC 4       %d ", $time);
      `OPC_DIV    : $display("DIV         %d ", $time);
      `OPC_DJNZ_1 : $display("DJNZ 1      %d ", $time);
      `OPC_DJNZ_2 : $display("DJNZ 2      %d ", $time);
      `OPC_INC_1  : $display("INC 1       %d ", $time);
      `OPC_INC_2  : $display("INC 2       %d ", $time);
      `OPC_INC_3  : $display("INC 3       %d ", $time);
      `OPC_INC_4  : $display("INC 4       %d ", $time);
      `OPC_INC_5  : $display("INC 5       %d ", $time);
      `OPC_JB     : $display("JB          %d ", $time);
      `OPC_JBC    : $display("JBC         %d ", $time);
      `OPC_JC     : $display("JC          %d ", $time);
      `OPC_JMP    : $display("JMP         %d ", $time);
      `OPC_JNB    : $display("JNB         %d ", $time);
      `OPC_JNC    : $display("JNC         %d ", $time);
      `OPC_JNZ    : $display("JNZ         %d ", $time);
      `OPC_JZ     : $display("JZ          %d ", $time);
      `OPC_LCALL  : $display("LCALL       %d ", $time);
      `OPC_LJMP   : $display("LJMP        %d ", $time);
      `OPC_MOV_1  : $display("MOV 1       %d ", $time);
      `OPC_MOV_2  : $display("MOV 2       %d ", $time);
      `OPC_MOV_3  : $display("MOV 3       %d ", $time);
      `OPC_MOV_4  : $display("MOV 4       %d ", $time);
      `OPC_MOV_5  : $display("MOV 5       %d ", $time);
      `OPC_MOV_6  : $display("MOV 6       %d ", $time);
      `OPC_MOV_7  : $display("MOV 7       %d ", $time);
      `OPC_MOV_8  : $display("MOV 8       %d ", $time);
      `OPC_MOV_9  : $display("MOV 9       %d ", $time);
      `OPC_MOV_10 : $display("MOV 10      %d ", $time);
      `OPC_MOV_11 : $display("MOV 11      %d ", $time);
      `OPC_MOV_12 : $display("MOV 12      %d ", $time);
      `OPC_MOV_13 : $display("MOV 13      %d ", $time);
      `OPC_MOV_14 : $display("MOV 14      %d ", $time);
      `OPC_MOV_15 : $display("MOV 15      %d ", $time);
      `OPC_MOV_16 : $display("MOV 16      %d ", $time);
      `OPC_MOV_17 : $display("MOV 17      %d ", $time);
      `OPC_MOV_18 : $display("MOV 18      %d ", $time);
      `OPC_MOVC_1 : $display("MOVC 1      %d ", $time);
      `OPC_MOVC_2 : $display("MOVC 2      %d ", $time);
      `OPC_MOVX_1 : $display("MOVX 1      %d ", $time);
      `OPC_MOVX_2 : $display("MOVX 2      %d ", $time);
      `OPC_MOVX_3 : $display("MOVX 3      %d ", $time);
      `OPC_MOVX_4 : $display("MOVX 4      %d ", $time);
      `OPC_MUL    : $display("MUL         %d ", $time);
      `OPC_NOP    : $display("NOP         %d ", $time);
      `OPC_ORL_1  : $display("ORL 1       %d ", $time);
      `OPC_ORL_2  : $display("ORL 2       %d ", $time);
      `OPC_ORL_3  : $display("ORL 3       %d ", $time);
      `OPC_ORL_4  : $display("ORL 4       %d ", $time);
      `OPC_ORL_5  : $display("ORL 5       %d ", $time);
      `OPC_ORL_6  : $display("ORL 6       %d ", $time);
      `OPC_ORL_7  : $display("ORL 7       %d ", $time);
      `OPC_ORL_8  : $display("ORL 8       %d ", $time);
      `OPC_POP    : $display("POP         %d ", $time);
      `OPC_PUSH   : $display("PUSH        %d ", $time);
      `OPC_RET    : $display("RET         %d ", $time);
      `OPC_RETI   : $display("RETI        %d ", $time);
      `OPC_RL     : $display("RL          %d ", $time);
      `OPC_RLC    : $display("RLC         %d ", $time);
      `OPC_RR     : $display("RR          %d ", $time);
      `OPC_RRC    : $display("RRC         %d ", $time);
      `OPC_SETB_1 : $display("SETB 1      %d ", $time);
      `OPC_SETB_2 : $display("SETB 2      %d ", $time);
      `OPC_SJMP   : $display("SJMP        %d ", $time);
      `OPC_SUBB_1 : $display("SUBB 1      %d ", $time);
      `OPC_SUBB_2 : $display("SUBB 2      %d ", $time);
      `OPC_SUBB_3 : $display("SUBB 3      %d ", $time);
      `OPC_SUBB_4 : $display("SUBB 4      %d ", $time);
      `OPC_SWAP   : $display("SWAP        %d ", $time);
      `OPC_XCH_1  : $display("XCH 1       %d ", $time);
      `OPC_XCH_2  : $display("XCH 2       %d ", $time);
      `OPC_XCH_3  : $display("XCH 3       %d ", $time);
      `OPC_XCHD   : $display("XCHD        %d ", $time);
      `OPC_XRL_1  : $display("XRL 1       %d ", $time);
      `OPC_XRL_2  : $display("XRL 2       %d ", $time);
      `OPC_XRL_3  : $display("XRL 3       %d ", $time);
      `OPC_XRL_4  : $display("XRL 4       %d ", $time);
      `OPC_XRL_5  : $display("XRL 5       %d ", $time);
      `OPC_XRL_6  : $display("XRL 6       %d ", $time);
      default     : $display("            %d ", $time);
    endcase
    
  end
endmodule

//////////////////////////////////////////////////////////////////////////////-

// end of file //
