`include "time_scale.v"
`include "i8051_lib.v"

module sram (
  phy_clk,
  sram_adr_o,
  sram_data_i,
  sram_data_o,
  sram_re_o,
  sram_we_o 
);

input           phy_clk;
input 	[15:0]	sram_adr_o;
output  [ 7:0]	sram_data_i;
input 	[ 7:0]	sram_data_o;
input 		sram_re_o;
input 		sram_we_o;

reg  [ 7:0] mem [0:65535];
wire [ 7:0] mem_i;
wire [ 7:0] sram_data_out;
wire [ 7:0] sram_data_i_i;
reg  [ 7:0] sram_data_i;

assign sram_data_out=mem[sram_adr_o];
assign sram_data_i_i=sram_re_o ? sram_data_out : sram_data_i;
assign mem_i        =sram_we_o ? sram_data_o   : mem[sram_adr_o];
always @ (posedge phy_clk) begin
  sram_data_i <= sram_data_i_i;
  //
  mem[sram_adr_o] <= mem_i;
end


endmodule

